| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Macros | Enumerations | Functions
Host Management (AVR8)
Host Management

USB Host definitions for the AVR8 microcontrollers. More...

## Macros
#define | HOST_DEVICE_SETTLE_DELAY_MS 1000
#define | USB_HOST_DEVICEADDRESS 1

## Enumerations
enum | USB_Host_EnumerationErrorCodes_t { HOST_ENUMERROR_NoError = 0, HOST_ENUMERROR_WaitStage = 1, HOST_ENUMERROR_NoDeviceDetected = 2, HOST_ENUMERROR_ControlError = 3, HOST_ENUMERROR_PipeConfigError = 4, HOST_ENUMERROR_NoError = 0, HOST_ENUMERROR_WaitStage = 1, HOST_ENUMERROR_NoDeviceDetected = 2, HOST_ENUMERROR_ControlError = 3, HOST_ENUMERROR_PipeConfigError = 4 }
enum | USB_Host_ErrorCodes_t { HOST_ERROR_VBusVoltageDip = 0, HOST_ERROR_VBusVoltageDip = 0 }

## Functions
static void | USB_Host_ClearRemoteWakeupSent (void) ATTR_ALWAYS_INLINE
static void | USB_Host_DisableSOFEvents (void) ATTR_ALWAYS_INLINE
static void | USB_Host_EnableSOFEvents (void) ATTR_ALWAYS_INLINE
static uint16_t | USB_Host_GetFrameNumber (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static bool | USB_Host_IsBusResetComplete (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static bool | USB_Host_IsBusSuspended (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static bool | USB_Host_IsDeviceFullSpeed (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static bool | USB_Host_IsRemoteWakeupSent (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static bool | USB_Host_IsResumeFromWakeupRequestSent (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
static void | USB_Host_ResetBus (void) ATTR_ALWAYS_INLINE
static void | USB_Host_ResumeBus (void) ATTR_ALWAYS_INLINE
static void | USB_Host_ResumeFromWakeupRequest (void) ATTR_ALWAYS_INLINE
static void | USB_Host_SuspendBus (void) ATTR_ALWAYS_INLINE

## Detailed Description

Architecture specific USB Host definitions for the Atmel 8-bit AVR microcontrollers.

## Macro Definition Documentation

#define HOST_DEVICE_SETTLE_DELAY_MS 1000

Constant for the delay in milliseconds after a device is connected before the library will start the enumeration process. Some devices require a delay of up to 5 seconds after connection before the enumeration process can start or incorrect operation will occur.

The default delay value may be overridden in the user project makefile by defining the `HOST_DEVICE_SETTLE_DELAY_MS` token to the required delay in milliseconds, and passed to the compiler using the -D switch.

#define USB_HOST_DEVICEADDRESS 1

Indicates the fixed USB device address which any attached device is enumerated to when in host mode. As only one USB device may be attached to the AVR in host mode at any one time and that the address used is not important (other than the fact that it is non-zero), a fixed value is specified by the library.

## Enumeration Type Documentation

enum USB_Host_EnumerationErrorCodes_t

Enum for the error codes for the EVENT_USB_Host_DeviceEnumerationFailed() event.

See also
  USB Events for more information on this event.

Enumerator
HOST_ENUMERROR_NoError | No error occurred. Used internally, this is not a valid ErrorCode parameter value for the EVENT_USB_Host_DeviceEnumerationFailed() event.
HOST_ENUMERROR_WaitStage | One of the delays between enumeration steps failed to complete successfully, due to a timeout or other error.
HOST_ENUMERROR_NoDeviceDetected | No device was detected, despite the USB data lines indicating the attachment of a device.
HOST_ENUMERROR_ControlError | One of the enumeration control requests failed to complete successfully.
HOST_ENUMERROR_PipeConfigError | The default control pipe (address 0) failed to configure correctly.
HOST_ENUMERROR_NoError | No error occurred. Used internally, this is not a valid ErrorCode parameter value for the EVENT_USB_Host_DeviceEnumerationFailed() event.
HOST_ENUMERROR_WaitStage | One of the delays between enumeration steps failed to complete successfully, due to a timeout or other error.
HOST_ENUMERROR_NoDeviceDetected | No device was detected, despite the USB data lines indicating the attachment of a device.
HOST_ENUMERROR_ControlError | One of the enumeration control requests failed to complete successfully.
HOST_ENUMERROR_PipeConfigError | The default control pipe (address 0) failed to configure correctly.

enum USB_Host_ErrorCodes_t

Enum for the error codes for the EVENT_USB_Host_HostError() event.

See also
  USB Events for more information on this event.

Enumerator
HOST_ERROR_VBusVoltageDip | VBUS voltage dipped to an unacceptable level. This error may be the result of an attached device drawing too much current from the VBUS line, or due to the AVR's power source being unable to supply sufficient current.
HOST_ERROR_VBusVoltageDip | VBUS voltage dipped to an unacceptable level. This error may be the result of an attached device drawing too much current from the VBUS line, or due to the AVR's power source being unable to supply sufficient current.

## Function Documentation

static void USB_Host_ClearRemoteWakeupSent | ( | void |  | ) |
| inline static

Clears the flag indicating that a Remote Wakeup request has been issued by an attached device.

static void USB_Host_DisableSOFEvents | ( | void |  | ) |
| inline static

Disables the host mode Start Of Frame events. When disabled, this stops the firing of the EVENT_USB_Host_StartOfFrame() event when enumerated in host mode.

Note
  This function is not available when the `NO_SOF_EVENTS` compile time token is defined.

static void USB_Host_EnableSOFEvents | ( | void |  | ) |
| inline static

Enables the host mode Start Of Frame events. When enabled, this causes the EVENT_USB_Host_StartOfFrame() event to fire once per millisecond, synchronized to the USB bus, at the start of each USB frame when a device is enumerated while in host mode.

Note
  This function is not available when the `NO_SOF_EVENTS` compile time token is defined.

static uint16_t USB_Host_GetFrameNumber | ( | void |  | ) |
| inline static

Returns the current USB frame number, when in host mode. Every millisecond the USB bus is active (i.e. not suspended) the frame number is incremented by one.

Returns
  Current USB frame number from the USB controller.

static bool USB_Host_IsBusResetComplete | ( | void |  | ) |
| inline static

Determines if a previously issued bus reset (via the USB_Host_ResetBus() macro) has completed.

Returns
  Boolean `true` if no bus reset is currently being sent, `false` otherwise.

static bool USB_Host_IsBusSuspended | ( | void |  | ) |
| inline static

Determines if the USB bus has been suspended via the use of the USB_Host_SuspendBus() macro, false otherwise. While suspended, no USB communications can occur until the bus is resumed, except for the Remote Wakeup event from the device if supported.

Returns
  Boolean `true` if the bus is currently suspended, `false` otherwise.

static bool USB_Host_IsDeviceFullSpeed | ( | void |  | ) |
| inline static

Determines if the attached device is currently enumerated in Full Speed mode (12Mb/s), or false if the attached device is enumerated in Low Speed mode (1.5Mb/s).

Returns
  Boolean `true` if the attached device is enumerated in Full Speed mode, `false` otherwise.

static bool USB_Host_IsRemoteWakeupSent | ( | void |  | ) |
| inline static

Determines if the attached device is currently issuing a Remote Wakeup request, requesting that the host resume the USB bus and wake up the device, `false` otherwise.

Returns
  Boolean `true` if the attached device has sent a Remote Wakeup request, `false` otherwise.

static bool USB_Host_IsResumeFromWakeupRequestSent | ( | void |  | ) |
| inline static

Determines if a resume from Remote Wakeup request is currently being sent to an attached device.

Returns
  Boolean `true` if no resume request is currently being sent, `false` otherwise.

static void USB_Host_ResetBus | ( | void |  | ) |
| inline static

Resets the USB bus, including the endpoints in any attached device and pipes on the AVR host. USB bus resets leave the default control pipe configured (if already configured).

If the USB bus has been suspended prior to issuing a bus reset, the attached device will be woken up automatically and the bus resumed after the reset has been correctly issued.

static void USB_Host_ResumeBus | ( | void |  | ) |
| inline static

Resumes USB communications with an attached and enumerated device, by resuming the transmission of the 1MS Start Of Frame messages to the device. When resumed, USB communications between the host and attached device may occur.

static void USB_Host_ResumeFromWakeupRequest | ( | void |  | ) |
| inline static

Accepts a Remote Wakeup request from an attached device. This must be issued in response to a device's Remote Wakeup request within 2ms for the request to be accepted and the bus to be resumed.

static void USB_Host_SuspendBus | ( | void |  | ) |
| inline static

Suspends the USB bus, preventing any communications from occurring between the host and attached device until the bus has been resumed. This stops the transmission of the 1MS Start Of Frame messages to the device.

Attention
  While the USB bus is suspended, all USB interrupt sources are also disabled; this means that some events (such as device disconnections) will not fire until the bus is resumed.